package dev.struchkov.godfather.quarkus.context.repository;

import dev.struchkov.haiti.utils.container.ContextKey;
import io.smallrye.mutiny.Uni;
import org.jetbrains.annotations.NotNull;

import java.util.Map;

public interface StorylineContext {

    <T> Uni<Void> save(@NotNull String personId, @NotNull ContextKey<T> key, T objectForSave);

    <T> Uni<T> getByKey(@NotNull String personId, @NotNull ContextKey<T> key);

    <T> Uni<T> removeKey(@NotNull String personId, @NotNull ContextKey<T> key);

    <T> Uni<T> getByKeyOrThrow(@NotNull String personId, @NotNull ContextKey<T> key);

    Uni<Map<String, Object>> getAllSaveElement(@NotNull String personId);

    Uni<Void> removeAll(@NotNull String personId);

}
