package dev.struchkov.godfather.simple.context.repository;

import dev.struchkov.haiti.utils.container.ContextKey;
import org.jetbrains.annotations.NotNull;

import java.util.Map;
import java.util.Optional;

public interface StorylineContext {

    <T> void save(@NotNull String personId, @NotNull ContextKey<T> key, T objectForSave);

    <T> Optional<T> getByKey(@NotNull String personId, @NotNull ContextKey<T> key);

    <T> Optional<T> removeKey(@NotNull String personId, @NotNull ContextKey<T> key);

    <T> T getByKeyOrThrow(@NotNull String personId, @NotNull ContextKey<T> key);

    Map<String, Object> getAllSaveElement(@NotNull String personId);

    void removeAll(@NotNull String personId);

}
