package dev.struchkov.godfather.simple.context.service;

import dev.struchkov.godfather.main.domain.SendType;
import dev.struchkov.godfather.simple.domain.BoxAnswer;
import dev.struchkov.godfather.simple.domain.SentBox;
import org.jetbrains.annotations.NotNull;

import java.util.Optional;

/**
 * Интерфейс для отправки ответов пользователю.
 *
 * @author upagge [08/07/2019]
 */
public interface Sending {

    /**
     * Отравляет сообщение пользователю.
     *
     * @param boxAnswer Объект с данными, которые необходимо отправить
     */
    Optional<SentBox> send(@NotNull BoxAnswer boxAnswer);

    /**
     * Возвращает тип объекта отправляющего ответ пользователя. В зависимости от типа ответ будет отправлен с помощью
     * разных методов.
     */
    SendType getType();

}
