package dev.struchkov.godfather.quarkus.core.action;

import dev.struchkov.godfather.main.domain.content.Message;
import dev.struchkov.godfather.quarkus.core.Responder;
import dev.struchkov.godfather.quarkus.domain.unit.MainUnit;
import dev.struchkov.godfather.quarkus.domain.unit.SwitchUnit;
import dev.struchkov.godfather.quarkus.domain.unit.UnitRequest;
import io.smallrye.mutiny.Uni;

import java.util.Set;

import static dev.struchkov.haiti.utils.Checker.checkNotNull;

public class SwitchUnitAction implements ActionUnit<SwitchUnit<Message>, Message> {

    @Override
    public Uni<UnitRequest<MainUnit, Message>> action(UnitRequest<SwitchUnit<Message>, Message> unitRequest) {
        final SwitchUnit<Message> unit = unitRequest.getUnit();
        final Message message = unitRequest.getMessage();

        final Set<MainUnit<Message>> nextUnits = unit.getNextUnits();
        return Responder.nextUnit(message, nextUnits)
                .map(nextUnit -> {
                    if (checkNotNull(nextUnit)) {
                        return UnitRequest.of(nextUnit, message);
                    }
                    return UnitRequest.of(unit, message);
                });
    }

    @Override
    public String getUnitType() {
        return SwitchUnit.TYPE;
    }

    @Override
    public Class<Message> getMessageType() {
        return Message.class;
    }

}
