package dev.struchkov.godfather.simple.core.action.cmd;

import dev.struchkov.godfather.main.domain.content.Message;
import dev.struchkov.godfather.simple.core.action.ActionUnit;
import dev.struchkov.godfather.simple.domain.unit.MainUnit;
import dev.struchkov.godfather.simple.domain.unit.UnitRequest;
import dev.struchkov.godfather.simple.domain.unit.cmd.ReplaceCmd;

public class ReplaceCmdAction implements ActionUnit<ReplaceCmd<Message>, Message> {

    @Override
    public UnitRequest<MainUnit, Message> action(UnitRequest<ReplaceCmd<Message>, Message> unitRequest) {
        final ReplaceCmd<Message> unit = unitRequest.getUnit();
        final Message message = unitRequest.getMessage();
        return UnitRequest.of(unit.getThisUnit(), message);
    }

    @Override
    public String getUnitType() {
        return ReplaceCmd.TYPE;
    }

    @Override
    public Class<Message> getMessageType() {
        return Message.class;
    }

}
