package dev.struchkov.godfather.simple.core.provider;

import dev.struchkov.godfather.main.domain.EventContainer;
import dev.struchkov.godfather.main.domain.content.ChatMail;
import dev.struchkov.godfather.simple.context.service.EventHandler;
import dev.struchkov.godfather.simple.core.GeneralAutoResponder;

public class ChatStoryLineHandler implements EventHandler<ChatMail> {

    private final GeneralAutoResponder<ChatMail> generalAutoResponder;

    public ChatStoryLineHandler(GeneralAutoResponder<ChatMail> generalAutoResponder) {
        this.generalAutoResponder = generalAutoResponder;
    }

    @Override
    public void handle(EventContainer<ChatMail> message) {
        generalAutoResponder.processingNewMessage(message.getObject());
    }

    @Override
    public Class<ChatMail> getEventClass() {
        return ChatMail.class;
    }

}
