package dev.struchkov.godfather.simple.core.provider;

import dev.struchkov.godfather.main.domain.EventContainer;
import dev.struchkov.godfather.main.domain.content.Mail;
import dev.struchkov.godfather.simple.context.service.EventHandler;
import dev.struchkov.godfather.simple.core.GeneralAutoResponder;

public class PersonStoryLineHandler implements EventHandler<Mail> {

    private final GeneralAutoResponder<Mail> generalAutoResponder;

    public PersonStoryLineHandler(GeneralAutoResponder<Mail> generalAutoResponder) {
        this.generalAutoResponder = generalAutoResponder;
    }

    @Override
    public void handle(EventContainer<Mail> event) {
        generalAutoResponder.processingNewMessage(event.getObject());
    }

    @Override
    public Class<Mail> getEventClass() {
        return Mail.class;
    }

}
