package dev.struchkov.godfather.simple.core.pusher;

import dev.struchkov.godfather.simple.context.service.Sending;
import dev.struchkov.godfather.simple.domain.BoxAnswer;
import dev.struchkov.godfather.simple.domain.unit.func.Pusher;

import java.util.Map;

import static dev.struchkov.godfather.simple.domain.BoxAnswer.boxAnswer;

public class UserSanderPusher implements Pusher<String> {

    private final String personId;
    private final String nameForm;
    private final Sending sending;

    public UserSanderPusher(String personId, String nameForm, Sending sending) {
        this.personId = personId;
        this.nameForm = nameForm;
        this.sending = sending;
    }

    @Override
    public void push(String personId, Map<String, String> saveElement) {
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("========= ").append(nameForm).append(" =========\n");
        saveElement.forEach((key, value) -> stringBuilder.append(key).append(": ").append(value).append("\n"));
        stringBuilder.append("====================");
        final BoxAnswer boxAnswer = boxAnswer(stringBuilder.toString());
        boxAnswer.setRecipientIfNull(this.personId);
        sending.send(boxAnswer);
    }

}
