package dev.struchkov.godfather.main.domain.content;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Сообщение от пользователя типа "Личное сообщение".
 *
 * @author upagge [08/07/2019]
 */

@Getter
@Setter
@ToString
@EqualsAndHashCode(onlyExplicitlyIncluded = true, callSuper = true)
public class Mail extends Message {

    public static final String TYPE = "MAIL";

    /**
     * Имя отправителя.
     */
    private String firstName;

    /**
     * Фамилия отправителя.
     */
    private String lastName;

    /**
     * Вложения к сообщению.
     */
    private List<Attachment> attachments = new ArrayList<>();

    /**
     * Сообщение на которое дан ответ.
     */
    private Mail replayMail;

    /**
     * Пересланные сообщения.
     */
    private List<Mail> forwardMail;

    public Mail() {
        contentType = ContentType.MAIL;
    }

    public void addAttachment(Attachment attachment) {
        this.attachments.add(attachment);
    }

    public void addAttachments(Collection<Attachment> attachments) {
        this.attachments.addAll(attachments);
    }


}
