package dev.struchkov.godfather.main.domain.jackson;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import dev.struchkov.haiti.utils.container.ContextKey;

import java.io.IOException;
import java.util.Map;

public class TelegramPayloadSerializer extends StdSerializer<Map<ContextKey, Object>> {

    public TelegramPayloadSerializer() {
        this(null);
    }

    public TelegramPayloadSerializer(Class<Map<ContextKey, Object>> t) {
        super(t);
    }

    @Override
    public void serialize(Map<ContextKey, Object> value, JsonGenerator gen, SerializerProvider provider) throws IOException {
        gen.writeStartObject();

        for (Map.Entry<ContextKey, Object> entry : value.entrySet()) {
            ContextKey<?> key = entry.getKey();
            String keyString = key.getType().getName() + "@" + key.getValue();
            Object objectValue = entry.getValue();

            gen.writeObjectField(keyString, objectValue);
        }

        gen.writeEndObject();
    }


}

