package dev.struchkov.godfather.quarkus.domain.unit.func;

import io.smallrye.mutiny.Uni;

import java.util.function.Consumer;

public interface UniConsumer<T> {

    Uni<Void> accept(T t);

    static <D> UniConsumer<D> consumer(Consumer<D> consumer) {
        return t -> Uni.createFrom().deferred(() -> {
            consumer.accept(t);
            return Uni.createFrom().voidItem();
        });
    }

}
