package dev.struchkov.godfather.quarkus.domain.unit.func;

import io.smallrye.mutiny.Uni;

import java.util.function.Predicate;

public interface UniPredicate<T> {

    Uni<Boolean> test(T t);

    static <D> UniPredicate<D> predicate(Predicate<D> predicate) {
        return t -> Uni.createFrom().item(predicate.test(t));
    }

}
